#!/bin/bash
#
# script to generate Kerberos authentication requests
# 

# ssh server ip address
server="10.151.10.245"

# function to sleep for milliseconds
#
sleep_milliseconds () {
    s=$(( $RANDOM % 2 ))
    ms=$(( $RANDOM % 999 ))
    sleep $s.$ms
}

logmessage () {

    _tmpfile="/tmp/auth_log_message.log" 

    # check if logfile is greater than 500K, delete it if so.
    #
    (($(stat -c%s $_tmpfile) > 500000)) && rm -f $_tmpfile
    
    # create the log file if file does not exist
    #
    [[ ! -f $_tmpfile ]] && install -m 666 /dev/null $_tmpfile
    
    # record the message to file
    #
    echo $(date +"%T.%3N") $1 >> $_tmpfile
}

# script usage
#
if [ -z "$1" ]
then
    echo -e "[E] Usage: $0 <csv_file> "
    echo -e "[I] <csv_file> generated by uinfo_csv_gen.sh script"
    exit 1
fi

# check if sshpass is installed
#
sshpass=$(which sshpass)

if  [[ -z $sshpass ]]
then
    echo -e "[E] No SSH tool installed (sshpass)"
    echo -e "[I] Install sshpass pkg (apt install sshpass)"
    exit 1
fi

# file with users information
#
csv=$1

# saving users info in a variable
#
ui=$(cat $csv|grep -v username|cut -d "," -f 3-4)


# declaring associative array to save users information
#
declare -A users_pwds

# create index to use in for loop that fills up the users_pwds associative array
#
index=0

# read users info saved in $u line by line and fill up the associative array
#
for item in ${ui[@]}
do
    # adding item to the array
    #
    users_pwds[$index]=$(echo $item | awk -F"," '{ print $1 " " $2 }')

    # increment index
    #
    ((index++))
done

# start infinite loop
#
while :
do
    # create random indexes to randomize user authentication
    #
    r_index1=$[ $RANDOM % ${#users_pwds[@]} ]
    r_index2=$[ $RANDOM % (${#users_pwds[@]} - $r_index1) ]

    [[ $r_index2 -eq "0" ]] && continue
    
    for n in $(eval echo {$r_index1..$(($r_index1 + $r_index2))})
    do
        # get user and password from array for random index
        #
        _usr=$(echo ${users_pwds[$n]} |awk '{ print $1 }')
        _pwd=$(echo ${users_pwds[$n]} |awk '{ print $2 }')
        
        # authenticate user using sshpass tool
        # command is executed with a timeout of 1s 
        #
        timeout 5s $sshpass -p $_pwd ssh $_usr@$server "id" &>/dev/null

        # evaluate command execution and log message to logfile in /tmp
        #
        if  [ $? -eq 0 ]
        then
            logmessage "[I] sshpass::user $_usr::AUTH success"
        else
            logmessage "[E] sshpass::user $_usr::AUTH FAILED"
        fi
    
        # call function to sleep miliseconds
        #
        sleep_milliseconds 
    done
done


